﻿; ------------------------------------------------------------------------ ;

.scriptreference "System.Drawing.dll"
.incscript "Scripts/PalImage.cs"

; ------------------------------------------------------------------------ ;

.section Data

	; The image to be displayed.
	Image
		.incpalimage "Images/TI-83-TV.gif"

	; Displayed on home screen during demo.
	QuitMessage
		.byte "PAL Demo        "	
		.byte "----------------"
		.byte "                "
		.byte "Press [On] to   "
		.byte "exit.           "
		.byte "                "
		.byte "----------------"
		.byte "Ben Ryves 2007",0

.endsection

; ------------------------------------------------------------------------ ;

.enum Colour
	White = 0,
	Grey  = 1,
	Black = 2,
	Sync  = 3

; ------------------------------------------------------------------------ ;

	
	; Display the quit message.
	.bcall _clrLcdFull
	xor a
	ld (curCol),a
	ld (curRow),a
	
	ld hl,QuitMessage
	.bcall _putS

	; Disable interrupts (and im 1 for good measure).
	im 1
	di
	
PalLoop

	; Output five long syncs.
	ld b,5           ; 7
--	ld a,Colour.Sync ; 7
	out (bport),a    ; 11
	
	; Waste 144
	ld c,b   ; 4
	ld b,10  ; 7
-	djnz -   ; 13/8 (Wastes 8+(b-1)*13) = 125
	ld b,c   ; 4
	nop      ; 4

	ld a,Colour.Black ; 7
	out (bport),a     ; 11
	djnz --           ; 13/8

	; Output four short syncs.
	ld b,4            ; 7
--	ld a,Colour.Sync  ; 7
	out (bport),a     ; 11
	dec de            ; 6
	ld a,Colour.Black ; 7
	out (bport),a     ; 11
	
	; Waste 138
	push bc  ; 11
	ld b,8   ; 7
-	djnz -   ; 13/8 (Wastes 8+(b-1)*13) = 112
	pop bc   ; 11
	nop      ; 4
	inc de   ; 6	
	
	djnz --       ; 13/8
	
	ld a,Colour.Sync ; 7
	out (bport),a    ; 11
	dec de           ; 6
	
	ld a,Colour.Black ; 7
	out (bport),a     ; 11
	inc de            ; 6
	
	; We now have 32 - 8 = 24uS for processing = 144cc - 10 = 134cc.
	
	in a,(4)      ; 11
	bit 3,a       ; 8
	ret z         ; 5
	
	ld de,304     ; 11

	push hl \ pop hl ; 22
	push hl \ pop hl ; 22
	push hl \ pop hl ; 22
	push hl \ pop hl ; 22
	inc hl \ dec hl  ; 12
	
	ld hl,Image ; 11
	
HTrace

	; 4µs hsync pulse.
	ld a,Colour.Sync ; 7
	out (bport),a    ; 11
	dec de           ; 6
	
	; 8µs back porch.
	ld a,Colour.Black ; 7 \ 
	out (bport),a     ; 11 |- 4µs.
	dec de            ; 6 /
	
	ld c,bport    ; 7 \ 
	in a,(bport)  ; 11 |- 4µs.
	inc de        ; 6 /
	
	; 48µs picture.
	.rept 18 \ outi \ .loop
	
	; 1µs for the Hell of it.
	inc bc ; 6
	
	; 3µs (loop overhead).
	ld a,d        ; 4
	or e          ; 4
	jp nz,HTrace  ; 10 / 1
	
	jp PalLoop ; 10

; ------------------------------------------------------------------------ ;

.incsection Data ; Append the data section.

; ------------------------------------------------------------------------ ;